#pragma once
#ifndef PARSODUS_BACKENDS_CPP_H
#define PARSODUS_BACKENDS_CPP_H

#include "Parsodus/backend.h"

namespace pds {
namespace backends {
	
	/**
	 * A backend that emits c++ code
	 */
	template<typename T>
	class CppLRBackend : public Backend {
		public:
			CppLRBackend(util::ParserType parserType): Backend(), m_parserType(parserType) {}

			~CppLRBackend() {}

			std::string getName() {
                return "c++";
            }
			bool canProcessLang(std::string lang) {
                for (char& c : lang)
                    c = std::tolower(c);
                return lang == "c++" || lang == "cpp" || lang == "cxx";
            }

            bool canGenerateParser(util::ParserType parserType) {
                return parserType == m_parserType;
            }
            
			void generateParser(std::function<std::unique_ptr<std::ostream>(std::string)> getOstreamForFileName, std::string parserName, const Config& config) {
                //TODO
            }
        private:
            util::ParserType m_parserType;
    };
}
}

#endif //PARSODUS_BACKENDS_CPP_H
